<?xml version="1.0" encoding="UTF-8"?>

<web-app version="2.4"
  xmlns="http://java.sun.com/xml/ns/j2ee"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee 
  http://java.sun.com/xml/ns/j2ee/web-app_2_4.xsd" >

  <servlet>
    <servlet-name>Index</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.IndexServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Index</servlet-name>
    <url-pattern>/index.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Graphs</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.GraphsServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Graphs</servlet-name>
    <url-pattern>/graphs.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>GraphsSubpages</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.graphs.GraphsSubpagesServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>GraphsSubpages</servlet-name>
    <url-pattern>/network.html</url-pattern>
  </servlet-mapping>
  <servlet-mapping>
    <servlet-name>GraphsSubpages</servlet-name>
    <url-pattern>/fast-exits.html</url-pattern>
  </servlet-mapping>
  <servlet-mapping>
    <servlet-name>GraphsSubpages</servlet-name>
    <url-pattern>/users.html</url-pattern>
  </servlet-mapping>
  <servlet-mapping>
    <servlet-name>GraphsSubpages</servlet-name>
    <url-pattern>/packages.html</url-pattern>
  </servlet-mapping>
  <servlet-mapping>
    <servlet-name>GraphsSubpages</servlet-name>
    <url-pattern>/performance.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Bubbles</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.graphs.BubblesServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Bubbles</servlet-name>
    <url-pattern>/bubbles.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Research</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.ResearchServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Research</servlet-name>
    <url-pattern>/research.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ResearchData</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.research.ResearchDataServlet
    </servlet-class>
    <init-param>
      <param-name>localDataDir</param-name>
      <param-value>
        /srv/metrics.torproject.org/db/data/
      </param-value>
    </init-param>
  </servlet>
  <servlet-mapping>
    <servlet-name>ResearchData</servlet-name>
    <url-pattern>/data.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ResearchPapers</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.research.ResearchPapersServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ResearchPapers</servlet-name>
    <url-pattern>/papers.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ResearchTools</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.research.ResearchToolsServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ResearchTools</servlet-name>
    <url-pattern>/tools.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ResearchFormats</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.research.ResearchFormatsServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ResearchFormats</servlet-name>
    <url-pattern>/formats.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Status</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.StatusServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Status</servlet-name>
    <url-pattern>/status.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>RelaySearch</servlet-name>
    <servlet-class>
      org.torproject.ernie.status.relaysearch.RelaySearchServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>RelaySearch</servlet-name>
    <url-pattern>/relay-search.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>GraphImage</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.graphs.GraphImageServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>GraphImage</servlet-name>
    <url-pattern>/networksize.png</url-pattern>
    <url-pattern>/networksize.pdf</url-pattern>
    <url-pattern>/networksize.svg</url-pattern>
    <url-pattern>/cloudbridges.png</url-pattern>
    <url-pattern>/cloudbridges.pdf</url-pattern>
    <url-pattern>/cloudbridges.svg</url-pattern>
    <url-pattern>/relaycountries.png</url-pattern>
    <url-pattern>/relaycountries.pdf</url-pattern>
    <url-pattern>/relaycountries.svg</url-pattern>
    <url-pattern>/relayflags.png</url-pattern>
    <url-pattern>/relayflags.pdf</url-pattern>
    <url-pattern>/relayflags.svg</url-pattern>
    <url-pattern>/versions.png</url-pattern>
    <url-pattern>/versions.pdf</url-pattern>
    <url-pattern>/versions.svg</url-pattern>
    <url-pattern>/platforms.png</url-pattern>
    <url-pattern>/platforms.pdf</url-pattern>
    <url-pattern>/platforms.svg</url-pattern>
    <url-pattern>/bandwidth.png</url-pattern>
    <url-pattern>/bandwidth.pdf</url-pattern>
    <url-pattern>/bandwidth.svg</url-pattern>
    <url-pattern>/bwhist-flags.png</url-pattern>
    <url-pattern>/bwhist-flags.pdf</url-pattern>
    <url-pattern>/bwhist-flags.svg</url-pattern>
    <url-pattern>/bandwidth-flags.png</url-pattern>
    <url-pattern>/bandwidth-flags.pdf</url-pattern>
    <url-pattern>/bandwidth-flags.svg</url-pattern>
    <url-pattern>/dirbytes.png</url-pattern>
    <url-pattern>/dirbytes.pdf</url-pattern>
    <url-pattern>/dirbytes.svg</url-pattern>
    <url-pattern>/direct-users.png</url-pattern>
    <url-pattern>/direct-users.pdf</url-pattern>
    <url-pattern>/direct-users.svg</url-pattern>
    <url-pattern>/bridge-users.png</url-pattern>
    <url-pattern>/bridge-users.pdf</url-pattern>
    <url-pattern>/bridge-users.svg</url-pattern>
    <url-pattern>/torperf.png</url-pattern>
    <url-pattern>/torperf.pdf</url-pattern>
    <url-pattern>/torperf.svg</url-pattern>
    <url-pattern>/torperf-failures.png</url-pattern>
    <url-pattern>/torperf-failures.pdf</url-pattern>
    <url-pattern>/torperf-failures.svg</url-pattern>
    <url-pattern>/connbidirect.png</url-pattern>
    <url-pattern>/connbidirect.pdf</url-pattern>
    <url-pattern>/connbidirect.svg</url-pattern>
    <url-pattern>/fast-exits.png</url-pattern>
    <url-pattern>/fast-exits.pdf</url-pattern>
    <url-pattern>/fast-exits.svg</url-pattern>
    <url-pattern>/almost-fast-exits.png</url-pattern>
    <url-pattern>/almost-fast-exits.pdf</url-pattern>
    <url-pattern>/almost-fast-exits.svg</url-pattern>
    <url-pattern>/userstats-relay-country.png</url-pattern>
    <url-pattern>/userstats-relay-country.pdf</url-pattern>
    <url-pattern>/userstats-relay-country.svg</url-pattern>
    <url-pattern>/userstats-bridge-country.png</url-pattern>
    <url-pattern>/userstats-bridge-country.pdf</url-pattern>
    <url-pattern>/userstats-bridge-country.svg</url-pattern>
    <url-pattern>/userstats-bridge-transport.png</url-pattern>
    <url-pattern>/userstats-bridge-transport.pdf</url-pattern>
    <url-pattern>/userstats-bridge-transport.svg</url-pattern>
    <url-pattern>/userstats-bridge-version.png</url-pattern>
    <url-pattern>/userstats-bridge-version.pdf</url-pattern>
    <url-pattern>/userstats-bridge-version.svg</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Csv</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.graphs.CsvServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Csv</servlet-name>
    <url-pattern>/csv/*</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ExoneraTor</servlet-name>
    <servlet-class>
      org.torproject.ernie.status.exonerator.ExoneraTorServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ExoneraTor</servlet-name>
    <url-pattern>/exonerator.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ServerDescriptor</servlet-name>
    <servlet-class>
      org.torproject.ernie.status.exonerator.ServerDescriptorServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ServerDescriptor</servlet-name>
    <url-pattern>/serverdesc</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>Consensus</servlet-name>
    <servlet-class>
      org.torproject.ernie.status.exonerator.ConsensusServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>Consensus</servlet-name>
    <url-pattern>/consensus</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>ConsensusHealthServlet</servlet-name>
    <servlet-class>
      org.torproject.ernie.status.doctor.ConsensusHealthServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>ConsensusHealthServlet</servlet-name>
    <url-pattern>/consensus-health.html</url-pattern>
  </servlet-mapping>

  <servlet>
    <servlet-name>GraphData</servlet-name>
    <servlet-class>
      org.torproject.ernie.web.graphs.GraphDataServlet
    </servlet-class>
  </servlet>
  <servlet-mapping>
    <servlet-name>GraphData</servlet-name>
    <url-pattern>/graphs/*</url-pattern>
  </servlet-mapping>

  <welcome-file-list>
    <welcome-file>index.html</welcome-file>
  </welcome-file-list>

  <error-page>
    <error-code>400</error-code>
    <location>/WEB-INF/error.jsp</location>
  </error-page>
  <error-page>
    <error-code>404</error-code>
    <location>/WEB-INF/error.jsp</location>
  </error-page>
  <error-page>
    <error-code>500</error-code>
    <location>/WEB-INF/error.jsp</location>
  </error-page>
  <error-page>
    <exception-type>java.lang.Throwable</exception-type>
    <location>/WEB-INF/error.jsp</location>
  </error-page>

  <resource-ref>
    <description>Tor Metrics Database</description>
    <res-ref-name>jdbc/tordir</res-ref-name>
    <res-type>javax.sql.DataSource</res-type>
    <res-auth>Container</res-auth>
  </resource-ref>

  <context-param>
    <param-name>rserveHost</param-name>
    <param-value>localhost</param-value>
  </context-param>
  <context-param>
    <param-name>rservePort</param-name>
    <param-value>6311</param-value>
  </context-param>
  <context-param>
    <param-name>maxCacheAge</param-name>
    <param-value>21600</param-value>
  </context-param>
  <context-param>
    <param-name>cachedGraphsDir</param-name>
    <param-value>
      /srv/metrics.torproject.org/web/rserve/graphs/
    </param-value>
  </context-param>

  <listener>
    <listener-class>
      org.torproject.ernie.web.graphs.RObjectGenerator
    </listener-class>
  </listener>

</web-app>

